#!/usr/bin/python 
import cPickle
import re
import sys
import string
import os

foomatic_data_dir = sys.argv[1]
jp_foomatic_data_dir = sys.argv[2]
printer_db_pickle_file = sys.argv[3]
gs_driver_file = sys.argv[4]

printer_db_file = foomatic_data_dir + '/00-overview.foo'
jp_printer_db_file = jp_foomatic_data_dir + '/00-overview.foo'

# Read perl data dumper format
raw_db = eval(re.sub(r'undef', 'None', re.sub(r'(^.*=|\n|;\s$)',' ', re.sub(r'=>',':',open(printer_db_file).read()))))
raw_jp_db = eval(re.sub(r'undef', 'None', re.sub(r'(^.*=|\n|;\s$)',' ', re.sub(r'=>',':',open(jp_printer_db_file).read()))))

gs_driver_hash = {}
for driver in map(lambda x: string.rstrip(x), open(gs_driver_file).readlines()):
	gs_driver_hash[driver] = None

printer_db = {}
def do_vendor_entry(vendor, vendor_entry, dir):
	global printer_db
	if len(vendor_entry) == 0:
		return
	for printer in vendor_entry:

		printer_id = str(printer['id'])
		printer['id'] = printer_id

		drivers = []
		driver_list = printer.get('drivers', [])
		for driver in driver_list:
			if not gs_driver_hash.has_key(driver):
				continue
			if not os.path.exists(dir + '/' + driver + '-' + printer_id + '.foo'):
				continue
			drivers.append(driver)

		if len(drivers) == 0:
			continue

		if printer_db.has_key(printer_id):
			old_printer = printer_db[printer_id]
			for each in drivers:
				try:
					old_printer['drivers'].index(each)
				except:
					old_printer['drivers'].append(each)
		else:
			printer['drivers'] = drivers
			printer['model'] = str(printer['model'])
			printer['vendor'] = vendor
			printer_db[printer_id] = printer

for vendor in raw_db.keys():
	vendor_entry = raw_db[vendor]
	do_vendor_entry(vendor, vendor_entry, foomatic_data_dir)

for vendor in raw_jp_db.keys():
	vendor_entry = raw_jp_db[vendor]
	do_vendor_entry(vendor, vendor_entry, jp_foomatic_data_dir)

file = open(printer_db_pickle_file, "w")
pickler = cPickle.Pickler(file)
pickler.dump(printer_db)

